- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Data Structures | Typedefs | Functions
Web

## Data Structures
struct | _Elm_Web_Menu
| Structure describing the menu of a popup. More...

## Typedefs
typedef struct _Elm_Web_Menu | Elm_Web_Menu
| Structure describing the menu of a popup. More...
typedef Evas_Object *(* | Elm_Web_Window_Open )(void *data, Evas_Object *obj, Eina_Bool js, const Elm_Web_Window_Features *window_features)
| Callback type for the create_window hook. More...
typedef Evas_Object *(* | Elm_Web_Dialog_Alert )(void *data, Evas_Object *obj, const char *message)
| Callback type for the JS alert hook. More...
typedef Evas_Object *(* | Elm_Web_Dialog_Confirm )(void *data, Evas_Object *obj, const char *message, Eina_Bool *ret)
| Callback type for the JS confirm hook. More...
typedef Evas_Object *(* | Elm_Web_Dialog_Prompt )(void *data, Evas_Object *obj, const char *message, const char *def_value, const char **value, Eina_Bool *ret)
| Callback type for the JS prompt hook. More...
typedef Evas_Object *(* | Elm_Web_Dialog_File_Selector )(void *data, Evas_Object *obj, Eina_Bool allows_multiple, Eina_List *accept_types, Eina_List **selected, Eina_Bool *ret)
| Callback type for the JS file selector hook. More...
typedef void(* | Elm_Web_Console_Message )(void *data, Evas_Object *obj, const char *message, unsigned int line_number, const char *source_id)
| Callback type for the JS console message hook. More...

## Functions
Eina_Bool | elm_need_web (void)
| Request that your elementary application needs web support. More...
EOAPI Eina_Bool | elm_obj_web_text_matches_highlight_set (Eina_Bool highlight)
| Sets whether to highlight the matched marks. More...
EOAPI Eina_Bool | elm_obj_web_text_matches_highlight_get (void)
| Get whether highlighting marks is enabled. More...
EOAPI void | elm_obj_web_useragent_set (const char *user_agent)
| Change useragent of a elm_web object. More...
EOAPI const char * | elm_obj_web_useragent_get (void)
| Return current useragent of elm_web object. More...
EOAPI Eina_Bool | elm_obj_web_url_set (const char *url)
| Sets the URL for the web object. More...
EOAPI const char * | elm_obj_web_url_get (void)
| Get the current URL for the object. More...
EOAPI void | elm_obj_web_bg_color_set (int r, int g, int b, int a)
| Sets the background color to be used by the web object. More...
EOAPI void | elm_obj_web_bg_color_get (int *r, int *g, int *b, int *a)
| Get the background color to be used by the web object. More...
EOAPI void | elm_obj_web_inwin_mode_set (Eina_Bool value)
| Sets the default dialogs to use an Inwin instead of a normal window. More...
EOAPI Eina_Bool | elm_obj_web_inwin_mode_get (void)
| Get whether Inwin mode is set for the current object. More...
EOAPI void | elm_obj_web_tab_propagate_set (Eina_Bool propagate)
| Sets whether to use tab propagation. More...
EOAPI Eina_Bool | elm_obj_web_tab_propagate_get (void)
| Get the status of the tab propagation. More...
EOAPI void | elm_obj_web_history_enabled_set (Eina_Bool enable)
| Enables or disables the browsing history. More...
EOAPI Eina_Bool | elm_obj_web_history_enabled_get (void)
| Get whether browsing history is enabled for the given object. More...
EOAPI void | elm_obj_web_zoom_mode_set (Elm_Web_Zoom_Mode mode)
| Sets the zoom mode to use. More...
EOAPI Elm_Web_Zoom_Mode | elm_obj_web_zoom_mode_get (void)
| Get the currently set zoom mode. More...
EOAPI void | elm_obj_web_zoom_set (double zoom)
| Sets the zoom level of the web object. More...
EOAPI double | elm_obj_web_zoom_get (void)
| Get the current zoom level set on the web object. More...
EOAPI void | elm_obj_web_console_message_hook_set (Elm_Web_Console_Message func, void *data)
| Sets the function to call when a console message is emitted from JS. More...
EOAPI void | elm_obj_web_window_create_hook_set (Elm_Web_Window_Open func, void *data)
| Sets the function to call when a new window is requested. More...
EOAPI void | elm_obj_web_dialog_file_selector_hook_set (Elm_Web_Dialog_File_Selector func, void *data)
| Sets the function to call when an file selector dialog. More...
EOAPI void | elm_obj_web_dialog_confirm_hook_set (Elm_Web_Dialog_Confirm func, void *data)
| Sets the function to call when an confirm dialog. More...
EOAPI void | elm_obj_web_popup_selected_set (int idx)
| Tells the web object which index in the currently open popup was selected. More...
EOAPI void | elm_obj_web_dialog_prompt_hook_set (Elm_Web_Dialog_Prompt func, void *data)
| Sets the function to call when an prompt dialog. More...
EOAPI void | elm_obj_web_dialog_alert_hook_set (Elm_Web_Dialog_Alert func, void *data)
| Sets the function to call when an alert dialog. More...
EOAPI Eina_Bool | elm_obj_web_forward_possible_get (void)
| Queries whether it's possible to go forward in history. More...
EOAPI Evas_Object * | elm_obj_web_webkit_view_get (void)
| Get internal ewk_view object from web object. More...
EOAPI Eina_Bool | elm_obj_web_back_possible_get (void)
| Queries whether it's possible to go back in history. More...
EOAPI double | elm_obj_web_load_progress_get (void)
| Get the overall loading progress of the page. More...
EOAPI const char * | elm_obj_web_selection_get (void)
| Get a copy of the currently selected text. More...
EOAPI const char * | elm_obj_web_title_get (void)
| Get the current title. More...
EOAPI Eina_Bool | elm_obj_web_navigate (int steps)
| Jumps the given number of steps in the browsing history. More...
EOAPI Eina_Bool | elm_obj_web_back (void)
| Goes back one step in the browsing history. More...
EOAPI Eina_Bool | elm_obj_web_html_string_load (const char *html, const char *base_url, const char *unreachable_url)
| Loads the specified html string as the content of the web object. More...
EOAPI Eina_Bool | elm_obj_web_text_search (const char *string, Eina_Bool case_sensitive, Eina_Bool forward, Eina_Bool wrap)
| Searches the given string in a document. More...
EOAPI Eina_Bool | elm_obj_web_popup_destroy (void)
| Dismisses an open dropdown popup. More...
EOAPI void | elm_obj_web_region_show (int x, int y, int w, int h)
| Shows the given region in the web object. More...
EOAPI Eina_Bool | elm_obj_web_forward (void)
| Goes forward one step in the browsing history. More...
EOAPI unsigned int | elm_obj_web_text_matches_mark (const char *string, Eina_Bool case_sensitive, Eina_Bool highlight, unsigned int limit)
| Marks matches of the given string in a document. More...
EOAPI void | elm_obj_web_region_bring_in (int x, int y, int w, int h)
| Brings in the region to the visible area. More...
EOAPI Eina_Bool | elm_obj_web_stop (void)
| Stops loading the current page. More...
EOAPI Eina_Bool | elm_obj_web_navigate_possible_get (int steps)
| Queries whether it's possible to jump the given number of steps. More...
EOAPI Eina_Bool | elm_obj_web_reload_full (void)
| Requests a reload of the current document, avoiding any existing caches. More...
EOAPI Eina_Bool | elm_obj_web_text_matches_unmark_all (void)
| Clears all marked matches in the document. More...
EOAPI Eina_Bool | elm_obj_web_reload (void)
| Requests a reload of the current document in the object. More...
bool | elm_web::navigate (int steps_) const
| Jumps the given number of steps in the browsing history. More...
bool | elm_web::back () const
| Goes back one step in the browsing history. More...
bool | elm_web::html_string_load (std::string html_, std::string base_url_, std::string unreachable_url_) const
| Loads the specified html string as the content of the web object. More...
bool | elm_web::text_search (std::string string_, bool case_sensitive_, bool forward_, bool wrap_) const
| Searches the given string in a document. More...
bool | elm_web::popup_destroy () const
| Dismisses an open dropdown popup. More...
void | elm_web::region_show (int x_, int y_, int w_, int h_) const
| Shows the given region in the web object. More...
bool | elm_web::forward () const
| Goes forward one step in the browsing history. More...
unsigned int | elm_web::text_matches_mark (std::string string_, bool case_sensitive_, bool highlight_, unsigned int limit_) const
| Marks matches of the given string in a document. More...
void | elm_web::region_bring_in (int x_, int y_, int w_, int h_) const
| Brings in the region to the visible area. More...
bool | elm_web::stop () const
| Stops loading the current page. More...
bool | elm_web::navigate_possible_get (int steps_) const
| Queries whether it's possible to jump the given number of steps. More...
bool | elm_web::reload_full () const
| Requests a reload of the current document, avoiding any existing caches. More...
bool | elm_web::text_matches_unmark_all () const
| Clears all marked matches in the document. More...
bool | elm_web::reload () const
| Requests a reload of the current document in the object. More...
Eina_Bool | elm_web_text_matches_highlight_set (Eo *obj, Eina_Bool highlight)
| Sets whether to highlight the matched marks. More...
Eina_Bool | elm_web_text_matches_highlight_get (const Eo *obj)
| Get whether highlighting marks is enabled. More...
void | elm_web_useragent_set (Eo *obj, const char *user_agent)
| Change useragent of a elm_web object. More...
const char * | elm_web_useragent_get (const Eo *obj)
| Return current useragent of elm_web object. More...
Eina_Bool | elm_web_url_set (Eo *obj, const char *url)
| Sets the URL for the web object. More...
const char * | elm_web_url_get (const Eo *obj)
| Get the current URL for the object. More...
void | elm_web_bg_color_set (Eo *obj, int r, int g, int b, int a)
| Sets the background color to be used by the web object. More...
void | elm_web_bg_color_get (const Eo *obj, int *r, int *g, int *b, int *a)
| Get the background color to be used by the web object. More...
void | elm_web_inwin_mode_set (Eo *obj, Eina_Bool value)
| Sets the default dialogs to use an Inwin instead of a normal window. More...
Eina_Bool | elm_web_inwin_mode_get (const Eo *obj)
| Get whether Inwin mode is set for the current object. More...
void | elm_web_tab_propagate_set (Eo *obj, Eina_Bool propagate)
| Sets whether to use tab propagation. More...
Eina_Bool | elm_web_tab_propagate_get (const Eo *obj)
| Get the status of the tab propagation. More...
void | elm_web_history_enabled_set (Eo *obj, Eina_Bool enable)
| Enables or disables the browsing history. More...
Eina_Bool | elm_web_history_enabled_get (const Eo *obj)
| Get whether browsing history is enabled for the given object. More...
void | elm_web_zoom_mode_set (Eo *obj, Elm_Web_Zoom_Mode mode)
| Sets the zoom mode to use. More...
Elm_Web_Zoom_Mode | elm_web_zoom_mode_get (const Eo *obj)
| Get the currently set zoom mode. More...
void | elm_web_zoom_set (Eo *obj, double zoom)
| Sets the zoom level of the web object. More...
double | elm_web_zoom_get (const Eo *obj)
| Get the current zoom level set on the web object. More...
void | elm_web_console_message_hook_set (Eo *obj, Elm_Web_Console_Message func, void *data)
| Sets the function to call when a console message is emitted from JS. More...
void | elm_web_window_create_hook_set (Eo *obj, Elm_Web_Window_Open func, void *data)
| Sets the function to call when a new window is requested. More...
void | elm_web_dialog_file_selector_hook_set (Eo *obj, Elm_Web_Dialog_File_Selector func, void *data)
| Sets the function to call when an file selector dialog. More...
void | elm_web_dialog_confirm_hook_set (Eo *obj, Elm_Web_Dialog_Confirm func, void *data)
| Sets the function to call when an confirm dialog. More...
void | elm_web_popup_selected_set (Eo *obj, int idx)
| Tells the web object which index in the currently open popup was selected. More...
void | elm_web_dialog_prompt_hook_set (Eo *obj, Elm_Web_Dialog_Prompt func, void *data)
| Sets the function to call when an prompt dialog. More...
void | elm_web_dialog_alert_hook_set (Eo *obj, Elm_Web_Dialog_Alert func, void *data)
| Sets the function to call when an alert dialog. More...
Eina_Bool | elm_web_forward_possible_get (const Eo *obj)
| Queries whether it's possible to go forward in history. More...
Evas_Object * | elm_web_webkit_view_get (const Eo *obj)
| Get internal ewk_view object from web object. More...
Eina_Bool | elm_web_back_possible_get (const Eo *obj)
| Queries whether it's possible to go back in history. More...
double | elm_web_load_progress_get (const Eo *obj)
| Get the overall loading progress of the page. More...
const char * | elm_web_selection_get (const Eo *obj)
| Get a copy of the currently selected text. More...
const char * | elm_web_title_get (const Eo *obj)
| Get the current title. More...
Eina_Bool | elm_web_navigate (Eo *obj, int steps)
| Jumps the given number of steps in the browsing history. More...
Eina_Bool | elm_web_back (Eo *obj)
| Goes back one step in the browsing history. More...
Eina_Bool | elm_web_html_string_load (Eo *obj, const char *html, const char *base_url, const char *unreachable_url)
| Loads the specified html string as the content of the web object. More...
Eina_Bool | elm_web_text_search (const Eo *obj, const char *string, Eina_Bool case_sensitive, Eina_Bool forward, Eina_Bool wrap)
| Searches the given string in a document. More...
Eina_Bool | elm_web_popup_destroy (Eo *obj)
| Dismisses an open dropdown popup. More...
void | elm_web_region_show (Eo *obj, int x, int y, int w, int h)
| Shows the given region in the web object. More...
Eina_Bool | elm_web_forward (Eo *obj)
| Goes forward one step in the browsing history. More...
unsigned int | elm_web_text_matches_mark (Eo *obj, const char *string, Eina_Bool case_sensitive, Eina_Bool highlight, unsigned int limit)
| Marks matches of the given string in a document. More...
void | elm_web_region_bring_in (Eo *obj, int x, int y, int w, int h)
| Brings in the region to the visible area. More...
Eina_Bool | elm_web_stop (Eo *obj)
| Stops loading the current page. More...
Eina_Bool | elm_web_navigate_possible_get (Eo *obj, int steps)
| Queries whether it's possible to jump the given number of steps. More...
Eina_Bool | elm_web_reload_full (Eo *obj)
| Requests a reload of the current document, avoiding any existing caches. More...
Eina_Bool | elm_web_text_matches_unmark_all (Eo *obj)
| Clears all marked matches in the document. More...
Eina_Bool | elm_web_reload (Eo *obj)
| Requests a reload of the current document in the object. More...
Eina_Bool | elm_web_window_features_property_get (const Elm_Web_Window_Features *wf, Elm_Web_Window_Feature_Flag flag)
| Get boolean properties from Elm_Web_Window_Features (such as statusbar, menubar, etc) that are on a window. More...
void | elm_web_window_features_region_get (const Elm_Web_Window_Features *wf, Evas_Coord *x, Evas_Coord *y, Evas_Coord *w, Evas_Coord *h)
| TODO : Add documentation. More...
Evas_Object * | elm_web_add (Evas_Object *parent)
| Add a new web object to the parent. More...
EINA_DEPRECATED Eina_Bool | elm_web_uri_set (Evas_Object *obj, const char *uri)
| Sets the URI for the web object. More...
EINA_DEPRECATED const char * | elm_web_uri_get (const Evas_Object *obj)
| Get the current URI for the object. More...

## Detailed Description

A web widget is used for displaying web pages (HTML/CSS/JS) using WebKit-EFL. You must have compiled Elementary with ewebkit support.

Signals that you can add callbacks for are:

- "download,request": A file download has been requested. Event info is a pointer to a Elm_Web_Download
- "editorclient,contents,changed": Editor client's contents changed
- "editorclient,selection,changed": Editor client's selection changed
- "frame,created": A new frame was created. Event info is an Evas_Object which can be handled with WebKit's ewk_frame API
- "icon,received": An icon was received by the main frame
- "inputmethod,changed": Input method changed. Event info is an Eina_Bool indicating whether it's enabled or not
- "js,windowobject,clear": JS window object has been cleared
- "link,hover,in": Mouse cursor is hovering over a link. Event info is a char *link[2], where the first string contains the URL the link points to, and the second one the title of the link
- "link,hover,out": Mouse cursor left the link
- "load,document,finished": Loading of a document finished. Event info is the frame that finished loading
- "load,error": Load failed. Event info is a pointer to Elm_Web_Frame_Load_Error
- "load,finished": Load finished. Event info is NULL on success, on error it's a pointer to Elm_Web_Frame_Load_Error
- "load,newwindow,show": A new window was created and is ready to be shown
- "load,progress": Overall load progress. Event info is a pointer to a double containing a value between 0.0 and 1.0
- "load,provisional": Started provisional load
- "load,started": Loading of a document started
- "menubar,visible,get": Queries if the menubar is visible. Event info is a pointer to Eina_Bool where the callback should set `EINA_TRUE` if the menubar is visible, or `EINA_FALSE` in case it's not
- "menubar,visible,set": Informs menubar visibility. Event info is an Eina_Bool indicating the visibility
- "popup,created": A dropdown widget was activated, requesting its popup menu to be created. Event info is a pointer to Elm_Web_Menu
- "popup,willdelete": The web object is ready to destroy the popup object created. Event info is a pointer to Elm_Web_Menu
- "ready": Page is fully loaded
- "scrollbars,visible,get": Queries visibility of scrollbars. Event info is a pointer to Eina_Bool where the visibility state should be set
- "scrollbars,visible,set": Informs scrollbars visibility. Event info is an Eina_Bool with the visibility state set
- "statusbar,text,set": Text of the statusbar changed. Even info is a string with the new text
- "statusbar,visible,get": Queries visibility of the status bar. Event info is a pointer to Eina_Bool where the visibility state should be set.
- "statusbar,visible,set": Informs statusbar visibility. Event info is an Eina_Bool with the visibility value
- "title,changed": Title of the main frame changed. Event info is a string with the new title
- "toolbars,visible,get": Queries visibility of toolbars. Event info is a pointer to Eina_Bool where the visibility state should be set
- "toolbars,visible,set": Informs the visibility of toolbars. Event info is an Eina_Bool with the visibility state
- "tooltip,text,set": Show and set text of a tooltip. Event info is a string with the text to show
- "uri,changed": URI of the main frame changed. Event info is a string (deprecated. use "url,changed" instead)
- "url,changed": URL of the main frame changed. Event info is a string with the new URI
- "view,resized": The web object internal's view changed sized
- "windows,close,request": A JavaScript request to close the current window was requested
- "zoom,animated,end": Animated zoom finished
- "focused" : When the web has received focus. (since 1.8)
- "unfocused" : When the web has lost focus. (since 1.8)

available styles:

- default

An example of use of web:

- web_example_01
- Web - Simple example

## Typedef Documentation

typedef void(* Elm_Web_Console_Message)(void *data, Evas_Object *obj, const char *message, unsigned int line_number, const char *source_id)

Callback type for the JS console message hook.

When a console message is added from JavaScript, any set function to the console message hook will be called for the user to handle. There is no default implementation of this hook.

Parameters

  data | User data pointer set when setting the hook function.
  obj | The elm_web object that originated the message.
  message | The message sent.
  line_number | The line number.
  source_id | Source id.

See also
  elm_web_console_message_hook_set()

typedef Evas_Object*(* Elm_Web_Dialog_Alert)(void *data, Evas_Object *obj, const char *message)

Callback type for the JS alert hook.

Parameters

  data | User data pointer set when setting the hook function.
  obj | The elm_web object requesting the new window.
  message | The message to show in the alert dialog.

Returns
  The object representing the alert dialog. Elm_Web will run a second main loop to handle the dialog and normal flow of the application will be restored when the object is deleted, so the user should handle the popup properly in order to delete the object when the action is finished. If the function returns `NULL` the popup will be ignored.

See also
  elm_web_dialog_alert_hook_set()

typedef Evas_Object*(* Elm_Web_Dialog_Confirm)(void *data, Evas_Object *obj, const char *message, Eina_Bool *ret)

Callback type for the JS confirm hook.

Parameters

  data | User data pointer set when setting the hook function.
  obj | The elm_web object requesting the new window.
  message | The message to show in the confirm dialog.
  ret | Pointer to store the user selection. `EINA_TRUE` if the user selected `Ok`, `EINA_FALSE` otherwise.

Returns
  The object representing the confirm dialog. Elm_Web will run a second main loop to handle the dialog and normal flow of the application will be restored when the object is deleted, so the user should handle the popup properly in order to delete the object when the action is finished. If the function returns `NULL` the popup will be ignored.

See also
  elm_web_dialog_confirm_hook_set()

typedef Evas_Object*(* Elm_Web_Dialog_File_Selector)(void *data, Evas_Object *obj, Eina_Bool allows_multiple, Eina_List *accept_types, Eina_List **selected, Eina_Bool *ret)

Callback type for the JS file selector hook.

Parameters

  data | User data pointer set when setting the hook function.
  obj | The elm_web object requesting the new window.
  allows_multiple | `EINA_TRUE` if multiple files can be selected.
  accept_types | Mime types accepted.
  selected | Pointer to store the list of malloc'ed strings containing the path to each file selected. Must be `NULL` if the file dialog is canceled.
  ret | Pointer to store the user selection. `EINA_TRUE` if the user selected `Ok`, `EINA_FALSE` otherwise.

Returns
  The object representing the file selector dialog. Elm_Web will run a second main loop to handle the dialog and normal flow of the application will be restored when the object is deleted, so the user should handle the popup properly in order to delete the object when the action is finished. If the function returns `NULL` the popup will be ignored.

See also
  elm_web_dialog_file selector_hook_set()

typedef Evas_Object*(* Elm_Web_Dialog_Prompt)(void *data, Evas_Object *obj, const char *message, const char *def_value, const char **value, Eina_Bool *ret)

Callback type for the JS prompt hook.

Parameters

  data | User data pointer set when setting the hook function.
  obj | The elm_web object requesting the new window.
  message | The message to show in the prompt dialog.
  def_value | The default value to present the user in the entry
  value | Pointer to store the value given by the user. Must be a malloc'ed string or `NULL` if the user canceled the popup.
  ret | Pointer to store the user selection. `EINA_TRUE` if the user selected `Ok`, `EINA_FALSE` otherwise.

Returns
  The object representing the prompt dialog. Elm_Web will run a second main loop to handle the dialog and normal flow of the application will be restored when the object is deleted, so the user should handle the popup properly in order to delete the object when the action is finished. If the function returns `NULL` the popup will be ignored.

See also
  elm_web_dialog_prompt_hook_set()

typedef struct _Elm_Web_Menu Elm_Web_Menu

Structure describing the menu of a popup.

This structure will be passed as the `event_info` for the "popup,create" signal, which is emitted when a dropdown menu is opened. Users wanting to handle these popups by themselves should listen to this signal and set the `handled` property of the struct to `EINA_TRUE`. Leaving this property as `EINA_FALSE` means that the user will not handle the popup and the default implementation will be used.

When the popup is ready to be dismissed, a "popup,willdelete" signal will be emitted to notify the user that it can destroy any objects and free all data related to it.

See also
  elm_web_popup_selected_set()
  elm_web_popup_destroy()

typedef Evas_Object*(* Elm_Web_Window_Open)(void *data, Evas_Object *obj, Eina_Bool js, const Elm_Web_Window_Features *window_features)

Callback type for the create_window hook.

Parameters

  data | User data pointer set when setting the hook function.
  obj | The elm_web object requesting the new window.
  js | Set to `EINA_TRUE` if the request was originated from JavaScript. `EINA_FALSE` otherwise.
  window_features | A pointer of #Elm_Web_Window_Features indicating the features requested for the new window.

Returns
  The `elm_web` widget where the request will be loaded. That is, if a new window or tab is created, the elm_web widget in it should be returned, and NOT the window object. Returning `NULL` should cancel the request.

See also
  elm_web_window_create_hook_set()

## Function Documentation

bool elm_web::back | ( |  | ) | const
| inline

Goes back one step in the browsing history.

This is equivalent to calling elm_web_object_navigate(obj, -1);

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

See also
  elm_web_history_enabled_set()
  elm_web_back_possible()
  elm_web_forward()
  elm_web_navigate()

References elm_obj_web_back().

Eina_Bool elm_need_web | ( | void |  | ) |

Request that your elementary application needs web support.

This initializes the Ewebkit library when called and if support exists it returns `EINA_TRUE`, otherwise returns `EINA_FALSE`. This must be called before any other function that deals with elm_web objects or ewk_view instances.

Examples:
  web_example_02.c.

EOAPI Eina_Bool elm_obj_web_back | ( | void |  | ) |

Goes back one step in the browsing history.

This is equivalent to calling elm_web_object_navigate(obj, -1);

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

See also
  elm_web_history_enabled_set()
  elm_web_back_possible()
  elm_web_forward()
  elm_web_navigate()

Referenced by elm_web::back(), and elm_web_back().

EOAPI Eina_Bool elm_obj_web_back_possible_get | ( | void |  | ) |

Queries whether it's possible to go back in history.

Returns
  `EINA_TRUE` if it's possible to back in history, `EINA_FALSE` otherwise

Referenced by elm_web_back_possible_get().

EOAPI void elm_obj_web_bg_color_get | ( | int * | r,
|  | int * | g,
|  | int * | b,
|  | int * | a
| ) |  |

Get the background color to be used by the web object.

This is the color that will be used by default when the loaded page does not set it's own. Color values are pre-multiplied.

Parameters

  [out] | r | Red component
  [out] | g | Green component
  [out] | b | Blue component
  [out] | a | Alpha component

Referenced by elm_web_bg_color_get().

EOAPI void elm_obj_web_bg_color_set | ( | int | r,
|  | int | g,
|  | int | b,
|  | int | a
| ) |  |

Sets the background color to be used by the web object.

This is the color that will be used by default when the loaded page does not set it's own. Color values are pre-multiplied.

Parameters

  [in] | r | Red component
  [in] | g | Green component
  [in] | b | Blue component
  [in] | a | Alpha component

Referenced by elm_web_bg_color_set().

EOAPI void elm_obj_web_console_message_hook_set | ( | Elm_Web_Console_Message | func,
|  | void * | data
| ) |  |

Sets the function to call when a console message is emitted from JS.

This hook will be called when a console message is emitted from JavaScript. There is no default implementation for this feature.

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

Referenced by elm_web_console_message_hook_set().

EOAPI void elm_obj_web_dialog_alert_hook_set | ( | Elm_Web_Dialog_Alert | func,
|  | void * | data
| ) |  |

Sets the function to call when an alert dialog.

This hook will be called when a JavaScript alert dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

Referenced by elm_web_dialog_alert_hook_set().

EOAPI void elm_obj_web_dialog_confirm_hook_set | ( | Elm_Web_Dialog_Confirm | func,
|  | void * | data
| ) |  |

Sets the function to call when an confirm dialog.

This hook will be called when a JavaScript confirm dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

Referenced by elm_web_dialog_confirm_hook_set().

EOAPI void elm_obj_web_dialog_file_selector_hook_set | ( | Elm_Web_Dialog_File_Selector | func,
|  | void * | data
| ) |  |

Sets the function to call when an file selector dialog.

This hook will be called when a JavaScript file selector dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

Referenced by elm_web_dialog_file_selector_hook_set().

EOAPI void elm_obj_web_dialog_prompt_hook_set | ( | Elm_Web_Dialog_Prompt | func,
|  | void * | data
| ) |  |

Sets the function to call when an prompt dialog.

This hook will be called when a JavaScript prompt dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

Referenced by elm_web_dialog_prompt_hook_set().

EOAPI Eina_Bool elm_obj_web_forward | ( | void |  | ) |

Goes forward one step in the browsing history.

This is equivalent to calling elm_web_object_navigate(obj, 1);

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

See also
  elm_web_history_enabled_set()
  elm_web_forward_possible_get()
  elm_web_back()
  elm_web_navigate()

Referenced by elm_web_forward(), and elm_web::forward().

EOAPI Eina_Bool elm_obj_web_forward_possible_get | ( | void |  | ) |

Queries whether it's possible to go forward in history.

Returns
  `EINA_TRUE` if it's possible to forward in history, `EINA_FALSE` otherwise

Referenced by elm_web_forward_possible_get().

EOAPI Eina_Bool elm_obj_web_history_enabled_get | ( | void |  | ) |

Get whether browsing history is enabled for the given object.

Returns
  `EINA_TRUE` if history is enabled, `EINA_FALSE` otherwise

Referenced by elm_web_history_enabled_get().

EOAPI void elm_obj_web_history_enabled_set | ( | Eina_Bool | enable | ) |

Enables or disables the browsing history.

Parameters

  [in] | enable | Whether to enable or disable the browsing history

Referenced by elm_web_history_enabled_set().

EOAPI Eina_Bool elm_obj_web_html_string_load | ( | const char * | html,
|  | const char * | base_url,
|  | const char * | unreachable_url
| ) |  |

Loads the specified html string as the content of the web object.

Returns
  `EINA_TRUE` if it the HTML was successfully loaded, `EINA_FALSE` otherwise

External objects such as stylesheets or images referenced in the HTML document are located relative to base_url.

If an unreachable_url is passed it is used as the url for the loaded content. This is typically used to display error pages for a failed load.

Since
  1.9

Parameters

  [in] | html | HTML data to load
  [in] | base_url | Base URL used for relative paths to external objects (optional)
  [in] | unreachable_url | URL that could not be reached (optional)

Referenced by elm_web_html_string_load(), and elm_web::html_string_load().

EOAPI Eina_Bool elm_obj_web_inwin_mode_get | ( | void |  | ) |

Get whether Inwin mode is set for the current object.

Returns
  `EINA_TRUE` if Inwin mode is set, `EINA_FALSE` otherwise

Referenced by elm_web_inwin_mode_get().

EOAPI void elm_obj_web_inwin_mode_set | ( | Eina_Bool | value | ) |

Sets the default dialogs to use an Inwin instead of a normal window.

If set, then the default implementation for the JavaScript dialogs and file selector will be opened in an Inwin. Otherwise they will use a normal separated window.

Parameters

  [in] | value | `EINA_TRUE` to use Inwin, `EINA_FALSE` to use a normal window

Referenced by elm_web_inwin_mode_set().

EOAPI double elm_obj_web_load_progress_get | ( | void |  | ) |

Get the overall loading progress of the page.

Returns the estimated loading progress of the page, with a value between 0.0 and 1.0. This is an estimated progress accounting for all the frames included in the page.

Returns
  A value between 0.0 and 1.0 indicating the progress, or -1.0 on failure

Referenced by elm_web_load_progress_get().

EOAPI Eina_Bool elm_obj_web_navigate | ( | int | steps | ) |

Jumps the given number of steps in the browsing history.

The `steps` value can be a negative integer to back in history, or a positive to move forward.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on error or if not enough history exists to jump the given number of steps

See also
  elm_web_history_enabled_set()
  elm_web_back()
  elm_web_forward()

Parameters

  [in] | steps | The number of steps to jump

Referenced by elm_web_navigate(), and elm_web::navigate().

EOAPI Eina_Bool elm_obj_web_navigate_possible_get | ( | int | steps | ) |

Queries whether it's possible to jump the given number of steps.

The `steps` value can be a negative integer to back in history, or a positive to move forward.

Returns
  `EINA_TRUE` if enough history exists to perform the given jump, `EINA_FALSE` otherwise

Parameters

  [in] | steps | The number of steps to check for

Referenced by elm_web_navigate_possible_get(), and elm_web::navigate_possible_get().

EOAPI Eina_Bool elm_obj_web_popup_destroy | ( | void |  | ) |

Dismisses an open dropdown popup.

When the popup from a dropdown widget is to be dismissed, either after selecting an option or to cancel it, this function must be called, which will later emit an "popup,willdelete" signal to notify the user that any memory and objects related to this popup can be freed.

Returns
  `EINA_TRUE` if the menu was successfully destroyed, or `EINA_FALSE` if there was no menu to destroy

Referenced by elm_web_popup_destroy(), and elm_web::popup_destroy().

EOAPI void elm_obj_web_popup_selected_set | ( | int | idx | ) |

Tells the web object which index in the currently open popup was selected.

When the user handles the popup creation from the "popup,created" signal, it needs to tell the web object which item was selected by calling this function with the index corresponding to the item.

See also
  elm_web_popup_destroy()

Parameters

  [in] | idx | The index selected

Referenced by elm_web_popup_selected_set().

EOAPI void elm_obj_web_region_bring_in | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Brings in the region to the visible area.

Like elm_web_region_show(), but it animates the scrolling of the object to show the area

Parameters

  [in] | x | The x coordinate of the region to show
  [in] | y | The y coordinate of the region to show
  [in] | w | The width of the region to show
  [in] | h | The height of the region to show

Referenced by elm_web_region_bring_in(), and elm_web::region_bring_in().

EOAPI void elm_obj_web_region_show | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Shows the given region in the web object.

Parameters

  [in] | x | The x coordinate of the region to show
  [in] | y | The y coordinate of the region to show
  [in] | w | The width of the region to show
  [in] | h | The height of the region to show

Referenced by elm_web_region_show(), and elm_web::region_show().

EOAPI Eina_Bool elm_obj_web_reload | ( | void |  | ) |

Requests a reload of the current document in the object.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Referenced by elm_web_reload(), and elm_web::reload().

EOAPI Eina_Bool elm_obj_web_reload_full | ( | void |  | ) |

Requests a reload of the current document, avoiding any existing caches.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Referenced by elm_web_reload_full(), and elm_web::reload_full().

EOAPI const char* elm_obj_web_selection_get | ( | void |  | ) |

Get a copy of the currently selected text.

The string returned must be freed by the user when it's done with it.

Returns
  A newly allocated string, or `NULL` if nothing is selected or an error occurred

Referenced by elm_web_selection_get().

EOAPI Eina_Bool elm_obj_web_stop | ( | void |  | ) |

Stops loading the current page.

Cancels the loading of the current page in the web object. This will cause a "load,error" signal to be emitted, with the is_cancellation flag set to `EINA_TRUE`.

Returns
  `EINA_TRUE` if the cancel was successful, `EINA_FALSE` otherwise

Referenced by elm_web_stop(), and elm_web::stop().

EOAPI Eina_Bool elm_obj_web_tab_propagate_get | ( | void |  | ) |

Get the status of the tab propagation.

Returns
  `EINA_TRUE` if tab propagation is enabled, `EINA_FALSE` otherwise

See also
  elm_web_tab_propagate_set()

Referenced by elm_web_tab_propagate_get().

EOAPI void elm_obj_web_tab_propagate_set | ( | Eina_Bool | propagate | ) |

Sets whether to use tab propagation.

If tab propagation is enabled, whenever the user presses the Tab key, Elementary will handle it and switch focus to the next widget. The default value is disabled, where WebKit will handle the Tab key to cycle focus though its internal objects, jumping to the next widget only when that cycle ends.

Parameters

  [in] | propagate | Whether to propagate Tab keys to Elementary or not

Referenced by elm_web_tab_propagate_set().

EOAPI Eina_Bool elm_obj_web_text_matches_highlight_get | ( | void |  | ) |

Get whether highlighting marks is enabled.

Returns
  `EINA_TRUE` is marks are set to be highlighted, `EINA_FALSE` otherwise

Referenced by elm_web_text_matches_highlight_get().

EOAPI Eina_Bool elm_obj_web_text_matches_highlight_set | ( | Eina_Bool | highlight | ) |

Sets whether to highlight the matched marks.

If enabled, marks set with elm_web_text_matches_mark() will be highlighted.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Parameters

  [in] | highlight | Whether to highlight the marks or not

Referenced by elm_web_text_matches_highlight_set().

EOAPI unsigned int elm_obj_web_text_matches_mark | ( | const char * | string,
|  | Eina_Bool | case_sensitive,
|  | Eina_Bool | highlight,
|  | unsigned int | limit
| ) |  |

Marks matches of the given string in a document.

Returns
  number of matched string

Parameters

  [in] | string | String to match
  [in] | case_sensitive | If match should be case sensitive or not
  [in] | highlight | If matches should be highlighted
  [in] | limit | Maximum amount of matches, or zero to unlimited

Referenced by elm_web_text_matches_mark(), and elm_web::text_matches_mark().

EOAPI Eina_Bool elm_obj_web_text_matches_unmark_all | ( | void |  | ) |

Clears all marked matches in the document.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Referenced by elm_web_text_matches_unmark_all(), and elm_web::text_matches_unmark_all().

EOAPI Eina_Bool elm_obj_web_text_search | ( | const char * | string,
|  | Eina_Bool | case_sensitive,
|  | Eina_Bool | forward,
|  | Eina_Bool | wrap
| ) |  |

Searches the given string in a document.

Returns
  `EINA_TRUE` if the given string was found, `EINA_FALSE` if not or failure

Parameters

  [in] | string | String to search
  [in] | case_sensitive | If search should be case sensitive or not
  [in] | forward | If search is from cursor and on or backwards
  [in] | wrap | If search should wrap at the end

Referenced by elm_web_text_search(), and elm_web::text_search().

EOAPI const char* elm_obj_web_title_get | ( | void |  | ) |

Get the current title.

The returned string must not be freed and is guaranteed to be stringshared.

Returns
  A stringshared internal string with the current title, or `NULL` on failure

Referenced by elm_web_title_get().

EOAPI const char* elm_obj_web_url_get | ( | void |  | ) |

Get the current URL for the object.

The returned string must not be freed and is guaranteed to be stringshared.

Returns
  A stringshared internal string with the current URL, or `NULL` on failure

Referenced by elm_web_uri_get(), and elm_web_url_get().

EOAPI Eina_Bool elm_obj_web_url_set | ( | const char * | url | ) |

Sets the URL for the web object.

It must be a full URL, with resource included, in the form http://www.enlightenment.org or file:///tmp/something.html

Returns
  `EINA_TRUE` if the URL could be set, `EINA_FALSE` if an error occurred.

Parameters

  [in] | url | The URL to set

Referenced by elm_web_uri_set(), and elm_web_url_set().

EOAPI const char* elm_obj_web_useragent_get | ( | void |  | ) |

Return current useragent of elm_web object.

Returns
  Useragent string

Referenced by elm_web_useragent_get().

EOAPI void elm_obj_web_useragent_set | ( | const char * | user_agent | ) |

Change useragent of a elm_web object.

Parameters

  [in] | user_agent | String for useragent

Referenced by elm_web_useragent_set().

EOAPI Evas_Object* elm_obj_web_webkit_view_get | ( | void |  | ) |

Get internal ewk_view object from web object.

Elementary may not provide some low level features of EWebKit, instead of cluttering the API with proxy methods we opted to return the internal reference. Be careful using it as it may interfere with elm_web behavior.

Returns
  The internal ewk_view object or `NULL` if it does not exist. (Failure to create or Elementary compiled without ewebkit)

See also
  elm_web_add()

Referenced by elm_web_webkit_view_get().

EOAPI void elm_obj_web_window_create_hook_set | ( | Elm_Web_Window_Open | func,
|  | void * | data
| ) |  |

Sets the function to call when a new window is requested.

This hook will be called when a request to create a new window is issued from the web page loaded. There is no default implementation for this feature, so leaving this unset or passing `NULL` in `func` will prevent new windows from opening.

Parameters

  [in] | func | The hook function to be called when a window is requested
  [in] | data | User data

Referenced by elm_web_window_create_hook_set().

EOAPI double elm_obj_web_zoom_get | ( | void |  | ) |

Get the current zoom level set on the web object.

Note that this is the zoom level set on the web object and not that of the underlying Webkit one. In the .ELM_WEB_ZOOM_MODE_MANUAL mode, the two zoom levels should match, but for the other two modes the Webkit zoom is calculated internally to match the chosen mode without changing the zoom level set for the web object.

Returns
  The zoom level set on the object

Referenced by elm_web_zoom_get().

EOAPI Elm_Web_Zoom_Mode elm_obj_web_zoom_mode_get | ( | void |  | ) |

Get the currently set zoom mode.

Returns
  The current zoom mode set for the object, or .ELM_WEB_ZOOM_MODE_LAST on error

Referenced by elm_web_zoom_mode_get().

EOAPI void elm_obj_web_zoom_mode_set | ( | Elm_Web_Zoom_Mode | mode | ) |

Sets the zoom mode to use.

The modes can be any of those defined in .Elm_Web_Zoom_Mode, except .ELM_WEB_ZOOM_MODE_LAST. The default is .ELM_WEB_ZOOM_MODE_MANUAL.

.ELM_WEB_ZOOM_MODE_MANUAL means the zoom level will be controlled with the elm_web_zoom_set() function. .ELM_WEB_ZOOM_MODE_AUTO_FIT will calculate the needed zoom level to make sure the entirety of the web object's contents are shown. .ELM_WEB_ZOOM_MODE_AUTO_FILL will calculate the needed zoom level to fit the contents in the web object's size, without leaving any space unused.

Parameters

  [in] | mode | The mode to set

Referenced by elm_web_zoom_mode_set().

EOAPI void elm_obj_web_zoom_set | ( | double | zoom | ) |

Sets the zoom level of the web object.

Zoom level matches the Webkit API, so 1.0 means normal zoom, with higher values meaning zoom in and lower meaning zoom out. This function will only affect the zoom level if the mode set with elm_web_zoom_mode_set() is .ELM_WEB_ZOOM_MODE_MANUAL.

Parameters

  [in] | zoom | The zoom level to set

Referenced by elm_web_zoom_set().

Evas_Object* elm_web_add | ( | Evas_Object * | parent | ) |

Add a new web object to the parent.

Parameters

  parent | The parent object.

Returns
  The new object or `NULL` if it cannot be created.

See also
  elm_web_url_set()
  elm_web_webkit_view_get()

Eina_Bool elm_web_back | ( | Eo * | obj | ) |

Goes back one step in the browsing history.

This is equivalent to calling elm_web_object_navigate(obj, -1);

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

See also
  elm_web_history_enabled_set()
  elm_web_back_possible()
  elm_web_forward()
  elm_web_navigate()

References elm_obj_web_back().

Eina_Bool elm_web_back_possible_get | ( | const Eo * | obj | ) |

Queries whether it's possible to go back in history.

Returns
  `EINA_TRUE` if it's possible to back in history, `EINA_FALSE` otherwise

References elm_obj_web_back_possible_get().

void elm_web_bg_color_get | ( | const Eo * | obj,
|  | int * | r,
|  | int * | g,
|  | int * | b,
|  | int * | a
| ) |  |

Get the background color to be used by the web object.

This is the color that will be used by default when the loaded page does not set it's own. Color values are pre-multiplied.

Parameters

  [out] | r | Red component
  [out] | g | Green component
  [out] | b | Blue component
  [out] | a | Alpha component

References elm_obj_web_bg_color_get().

void elm_web_bg_color_set | ( | Eo * | obj,
|  | int | r,
|  | int | g,
|  | int | b,
|  | int | a
| ) |  |

Sets the background color to be used by the web object.

This is the color that will be used by default when the loaded page does not set it's own. Color values are pre-multiplied.

Parameters

  [in] | r | Red component
  [in] | g | Green component
  [in] | b | Blue component
  [in] | a | Alpha component

References elm_obj_web_bg_color_set().

void elm_web_console_message_hook_set | ( | Eo * | obj,
|  | Elm_Web_Console_Message | func,
|  | void * | data
| ) |  |

Sets the function to call when a console message is emitted from JS.

This hook will be called when a console message is emitted from JavaScript. There is no default implementation for this feature.

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

References elm_obj_web_console_message_hook_set().

void elm_web_dialog_alert_hook_set | ( | Eo * | obj,
|  | Elm_Web_Dialog_Alert | func,
|  | void * | data
| ) |  |

Sets the function to call when an alert dialog.

This hook will be called when a JavaScript alert dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

References elm_obj_web_dialog_alert_hook_set().

void elm_web_dialog_confirm_hook_set | ( | Eo * | obj,
|  | Elm_Web_Dialog_Confirm | func,
|  | void * | data
| ) |  |

Sets the function to call when an confirm dialog.

This hook will be called when a JavaScript confirm dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

References elm_obj_web_dialog_confirm_hook_set().

void elm_web_dialog_file_selector_hook_set | ( | Eo * | obj,
|  | Elm_Web_Dialog_File_Selector | func,
|  | void * | data
| ) |  |

Sets the function to call when an file selector dialog.

This hook will be called when a JavaScript file selector dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

References elm_obj_web_dialog_file_selector_hook_set().

void elm_web_dialog_prompt_hook_set | ( | Eo * | obj,
|  | Elm_Web_Dialog_Prompt | func,
|  | void * | data
| ) |  |

Sets the function to call when an prompt dialog.

This hook will be called when a JavaScript prompt dialog is requested. If no function is set or `NULL` is passed in `func`, the default implementation will take place.

See also
  elm_web_inwin_mode_set()

Parameters

  [in] | func | The callback function to be used
  [in] | data | User data

References elm_obj_web_dialog_prompt_hook_set().

Eina_Bool elm_web_forward | ( | Eo * | obj | ) |

Goes forward one step in the browsing history.

This is equivalent to calling elm_web_object_navigate(obj, 1);

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

See also
  elm_web_history_enabled_set()
  elm_web_forward_possible_get()
  elm_web_back()
  elm_web_navigate()

References elm_obj_web_forward().

Eina_Bool elm_web_forward_possible_get | ( | const Eo * | obj | ) |

Queries whether it's possible to go forward in history.

Returns
  `EINA_TRUE` if it's possible to forward in history, `EINA_FALSE` otherwise

References elm_obj_web_forward_possible_get().

Eina_Bool elm_web_history_enabled_get | ( | const Eo * | obj | ) |

Get whether browsing history is enabled for the given object.

Returns
  `EINA_TRUE` if history is enabled, `EINA_FALSE` otherwise

References elm_obj_web_history_enabled_get().

void elm_web_history_enabled_set | ( | Eo * | obj,
|  | Eina_Bool | enable
| ) |  |

Enables or disables the browsing history.

Parameters

  [in] | enable | Whether to enable or disable the browsing history

References elm_obj_web_history_enabled_set().

Eina_Bool elm_web_html_string_load | ( | Eo * | obj,
|  | const char * | html,
|  | const char * | base_url,
|  | const char * | unreachable_url
| ) |  |

Loads the specified html string as the content of the web object.

Returns
  `EINA_TRUE` if it the HTML was successfully loaded, `EINA_FALSE` otherwise

External objects such as stylesheets or images referenced in the HTML document are located relative to base_url.

If an unreachable_url is passed it is used as the url for the loaded content. This is typically used to display error pages for a failed load.

Since
  1.9

Parameters

  [in] | html | HTML data to load
  [in] | base_url | Base URL used for relative paths to external objects (optional)
  [in] | unreachable_url | URL that could not be reached (optional)

References elm_obj_web_html_string_load().

Eina_Bool elm_web_inwin_mode_get | ( | const Eo * | obj | ) |

Get whether Inwin mode is set for the current object.

Returns
  `EINA_TRUE` if Inwin mode is set, `EINA_FALSE` otherwise

References elm_obj_web_inwin_mode_get().

void elm_web_inwin_mode_set | ( | Eo * | obj,
|  | Eina_Bool | value
| ) |  |

Sets the default dialogs to use an Inwin instead of a normal window.

If set, then the default implementation for the JavaScript dialogs and file selector will be opened in an Inwin. Otherwise they will use a normal separated window.

Parameters

  [in] | value | `EINA_TRUE` to use Inwin, `EINA_FALSE` to use a normal window

References elm_obj_web_inwin_mode_set().

double elm_web_load_progress_get | ( | const Eo * | obj | ) |

Get the overall loading progress of the page.

Returns the estimated loading progress of the page, with a value between 0.0 and 1.0. This is an estimated progress accounting for all the frames included in the page.

Returns
  A value between 0.0 and 1.0 indicating the progress, or -1.0 on failure

References elm_obj_web_load_progress_get().

Eina_Bool elm_web_navigate | ( | Eo * | obj,
|  | int | steps
| ) |  |

Jumps the given number of steps in the browsing history.

The `steps` value can be a negative integer to back in history, or a positive to move forward.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on error or if not enough history exists to jump the given number of steps

See also
  elm_web_history_enabled_set()
  elm_web_back()
  elm_web_forward()

Parameters

  [in] | steps | The number of steps to jump

References elm_obj_web_navigate().

Eina_Bool elm_web_navigate_possible_get | ( | Eo * | obj,
|  | int | steps
| ) |  |

Queries whether it's possible to jump the given number of steps.

The `steps` value can be a negative integer to back in history, or a positive to move forward.

Returns
  `EINA_TRUE` if enough history exists to perform the given jump, `EINA_FALSE` otherwise

Parameters

  [in] | steps | The number of steps to check for

References elm_obj_web_navigate_possible_get().

Eina_Bool elm_web_popup_destroy | ( | Eo * | obj | ) |

Dismisses an open dropdown popup.

When the popup from a dropdown widget is to be dismissed, either after selecting an option or to cancel it, this function must be called, which will later emit an "popup,willdelete" signal to notify the user that any memory and objects related to this popup can be freed.

Returns
  `EINA_TRUE` if the menu was successfully destroyed, or `EINA_FALSE` if there was no menu to destroy

References elm_obj_web_popup_destroy().

void elm_web_popup_selected_set | ( | Eo * | obj,
|  | int | idx
| ) |  |

Tells the web object which index in the currently open popup was selected.

When the user handles the popup creation from the "popup,created" signal, it needs to tell the web object which item was selected by calling this function with the index corresponding to the item.

See also
  elm_web_popup_destroy()

Parameters

  [in] | idx | The index selected

References elm_obj_web_popup_selected_set().

void elm_web_region_bring_in | ( | Eo * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Brings in the region to the visible area.

Like elm_web_region_show(), but it animates the scrolling of the object to show the area

Parameters

  [in] | x | The x coordinate of the region to show
  [in] | y | The y coordinate of the region to show
  [in] | w | The width of the region to show
  [in] | h | The height of the region to show

References elm_obj_web_region_bring_in().

void elm_web_region_show | ( | Eo * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Shows the given region in the web object.

Parameters

  [in] | x | The x coordinate of the region to show
  [in] | y | The y coordinate of the region to show
  [in] | w | The width of the region to show
  [in] | h | The height of the region to show

References elm_obj_web_region_show().

Eina_Bool elm_web_reload | ( | Eo * | obj | ) |

Requests a reload of the current document in the object.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

References elm_obj_web_reload().

Eina_Bool elm_web_reload_full | ( | Eo * | obj | ) |

Requests a reload of the current document, avoiding any existing caches.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

References elm_obj_web_reload_full().

const char* elm_web_selection_get | ( | const Eo * | obj | ) |

Get a copy of the currently selected text.

The string returned must be freed by the user when it's done with it.

Returns
  A newly allocated string, or `NULL` if nothing is selected or an error occurred

References elm_obj_web_selection_get().

Eina_Bool elm_web_stop | ( | Eo * | obj | ) |

Stops loading the current page.

Cancels the loading of the current page in the web object. This will cause a "load,error" signal to be emitted, with the is_cancellation flag set to `EINA_TRUE`.

Returns
  `EINA_TRUE` if the cancel was successful, `EINA_FALSE` otherwise

References elm_obj_web_stop().

Eina_Bool elm_web_tab_propagate_get | ( | const Eo * | obj | ) |

Get the status of the tab propagation.

Returns
  `EINA_TRUE` if tab propagation is enabled, `EINA_FALSE` otherwise

See also
  elm_web_tab_propagate_set()

References elm_obj_web_tab_propagate_get().

void elm_web_tab_propagate_set | ( | Eo * | obj,
|  | Eina_Bool | propagate
| ) |  |

Sets whether to use tab propagation.

If tab propagation is enabled, whenever the user presses the Tab key, Elementary will handle it and switch focus to the next widget. The default value is disabled, where WebKit will handle the Tab key to cycle focus though its internal objects, jumping to the next widget only when that cycle ends.

Parameters

  [in] | propagate | Whether to propagate Tab keys to Elementary or not

References elm_obj_web_tab_propagate_set().

Eina_Bool elm_web_text_matches_highlight_get | ( | const Eo * | obj | ) |

Get whether highlighting marks is enabled.

Returns
  `EINA_TRUE` is marks are set to be highlighted, `EINA_FALSE` otherwise

References elm_obj_web_text_matches_highlight_get().

Eina_Bool elm_web_text_matches_highlight_set | ( | Eo * | obj,
|  | Eina_Bool | highlight
| ) |  |

Sets whether to highlight the matched marks.

If enabled, marks set with elm_web_text_matches_mark() will be highlighted.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Parameters

  [in] | highlight | Whether to highlight the marks or not

References elm_obj_web_text_matches_highlight_set().

unsigned int elm_web_text_matches_mark | ( | Eo * | obj,
|  | const char * | string,
|  | Eina_Bool | case_sensitive,
|  | Eina_Bool | highlight,
|  | unsigned int | limit
| ) |  |

Marks matches of the given string in a document.

Returns
  number of matched string

Parameters

  [in] | string | String to match
  [in] | case_sensitive | If match should be case sensitive or not
  [in] | highlight | If matches should be highlighted
  [in] | limit | Maximum amount of matches, or zero to unlimited

References elm_obj_web_text_matches_mark().

Eina_Bool elm_web_text_matches_unmark_all | ( | Eo * | obj | ) |

Clears all marked matches in the document.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

References elm_obj_web_text_matches_unmark_all().

Eina_Bool elm_web_text_search | ( | const Eo * | obj,
|  | const char * | string,
|  | Eina_Bool | case_sensitive,
|  | Eina_Bool | forward,
|  | Eina_Bool | wrap
| ) |  |

Searches the given string in a document.

Returns
  `EINA_TRUE` if the given string was found, `EINA_FALSE` if not or failure

Parameters

  [in] | string | String to search
  [in] | case_sensitive | If search should be case sensitive or not
  [in] | forward | If search is from cursor and on or backwards
  [in] | wrap | If search should wrap at the end

References elm_obj_web_text_search().

const char* elm_web_title_get | ( | const Eo * | obj | ) |

Get the current title.

The returned string must not be freed and is guaranteed to be stringshared.

Returns
  A stringshared internal string with the current title, or `NULL` on failure

References elm_obj_web_title_get().

EINA_DEPRECATED const char* elm_web_uri_get | ( | const Evas_Object * | obj | ) |

Get the current URI for the object.

The returned string must not be freed and is guaranteed to be stringshared.

Parameters

  obj | The web object

Returns
  A stringshared internal string with the current URI, or `NULL` on failure

Deprecated:
  Use elm_web_url_get() instead

See also
  elm_web_url_get()

References elm_obj_web_url_get().

EINA_DEPRECATED Eina_Bool elm_web_uri_set | ( | Evas_Object * | obj,
|  | const char * | uri
| ) |  |

Sets the URI for the web object.

It must be a full URI, with resource included, in the form http://www.enlightenment.org or file:///tmp/something.html

Parameters

  obj | The web object
  uri | The URI to set

Returns
  `EINA_TRUE` if the URI could be set, `EINA_FALSE` if an error occurred.

Deprecated:
  Use elm_web_url_set() instead

See also
  elm_web_url_set()

References elm_obj_web_url_set().

const char* elm_web_url_get | ( | const Eo * | obj | ) |

Get the current URL for the object.

The returned string must not be freed and is guaranteed to be stringshared.

Returns
  A stringshared internal string with the current URL, or `NULL` on failure

References elm_obj_web_url_get().

Eina_Bool elm_web_url_set | ( | Eo * | obj,
|  | const char * | url
| ) |  |

Sets the URL for the web object.

It must be a full URL, with resource included, in the form http://www.enlightenment.org or file:///tmp/something.html

Returns
  `EINA_TRUE` if the URL could be set, `EINA_FALSE` if an error occurred.

Parameters

  [in] | url | The URL to set

References elm_obj_web_url_set().

const char* elm_web_useragent_get | ( | const Eo * | obj | ) |

Return current useragent of elm_web object.

Returns
  Useragent string

References elm_obj_web_useragent_get().

void elm_web_useragent_set | ( | Eo * | obj,
|  | const char * | user_agent
| ) |  |

Change useragent of a elm_web object.

Parameters

  [in] | user_agent | String for useragent

References elm_obj_web_useragent_set().

Evas_Object* elm_web_webkit_view_get | ( | const Eo * | obj | ) |

Get internal ewk_view object from web object.

Elementary may not provide some low level features of EWebKit, instead of cluttering the API with proxy methods we opted to return the internal reference. Be careful using it as it may interfere with elm_web behavior.

Returns
  The internal ewk_view object or `NULL` if it does not exist. (Failure to create or Elementary compiled without ewebkit)

See also
  elm_web_add()

References elm_obj_web_webkit_view_get().

void elm_web_window_create_hook_set | ( | Eo * | obj,
|  | Elm_Web_Window_Open | func,
|  | void * | data
| ) |  |

Sets the function to call when a new window is requested.

This hook will be called when a request to create a new window is issued from the web page loaded. There is no default implementation for this feature, so leaving this unset or passing `NULL` in `func` will prevent new windows from opening.

Parameters

  [in] | func | The hook function to be called when a window is requested
  [in] | data | User data

References elm_obj_web_window_create_hook_set().

Eina_Bool elm_web_window_features_property_get | ( | const Elm_Web_Window_Features * | wf,
|  | Elm_Web_Window_Feature_Flag | flag
| ) |  |

Get boolean properties from Elm_Web_Window_Features (such as statusbar, menubar, etc) that are on a window.

Parameters

  wf | The web window features object
  flag | The web window feature flag whose value is required.

Returns
  `EINA_TRUE` if the flag is set, `EINA_FALSE` otherwise

void elm_web_window_features_region_get | ( | const Elm_Web_Window_Features * | wf,
|  | Evas_Coord * | x,
|  | Evas_Coord * | y,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h
| ) |  |

TODO : Add documentation.

Parameters

  wf | The web window features object
  x,y,w,h | - the co-ordinates of the web view window.

double elm_web_zoom_get | ( | const Eo * | obj | ) |

Get the current zoom level set on the web object.

Note that this is the zoom level set on the web object and not that of the underlying Webkit one. In the .ELM_WEB_ZOOM_MODE_MANUAL mode, the two zoom levels should match, but for the other two modes the Webkit zoom is calculated internally to match the chosen mode without changing the zoom level set for the web object.

Returns
  The zoom level set on the object

References elm_obj_web_zoom_get().

Elm_Web_Zoom_Mode elm_web_zoom_mode_get | ( | const Eo * | obj | ) |

Get the currently set zoom mode.

Returns
  The current zoom mode set for the object, or .ELM_WEB_ZOOM_MODE_LAST on error

References elm_obj_web_zoom_mode_get().

void elm_web_zoom_mode_set | ( | Eo * | obj,
|  | Elm_Web_Zoom_Mode | mode
| ) |  |

Sets the zoom mode to use.

The modes can be any of those defined in .Elm_Web_Zoom_Mode, except .ELM_WEB_ZOOM_MODE_LAST. The default is .ELM_WEB_ZOOM_MODE_MANUAL.

.ELM_WEB_ZOOM_MODE_MANUAL means the zoom level will be controlled with the elm_web_zoom_set() function. .ELM_WEB_ZOOM_MODE_AUTO_FIT will calculate the needed zoom level to make sure the entirety of the web object's contents are shown. .ELM_WEB_ZOOM_MODE_AUTO_FILL will calculate the needed zoom level to fit the contents in the web object's size, without leaving any space unused.

Parameters

  [in] | mode | The mode to set

References elm_obj_web_zoom_mode_set().

void elm_web_zoom_set | ( | Eo * | obj,
|  | double | zoom
| ) |  |

Sets the zoom level of the web object.

Zoom level matches the Webkit API, so 1.0 means normal zoom, with higher values meaning zoom in and lower meaning zoom out. This function will only affect the zoom level if the mode set with elm_web_zoom_mode_set() is .ELM_WEB_ZOOM_MODE_MANUAL.

Parameters

  [in] | zoom | The zoom level to set

References elm_obj_web_zoom_set().

bool elm_web::forward | ( |  | ) | const
| inline

Goes forward one step in the browsing history.

This is equivalent to calling elm_web_object_navigate(obj, 1);

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

See also
  elm_web_history_enabled_set()
  elm_web_forward_possible_get()
  elm_web_back()
  elm_web_navigate()

References elm_obj_web_forward().

bool elm_web::html_string_load | ( | std::string | html_,
|  | std::string | base_url_,
|  | std::string | unreachable_url_
| ) |  | const
| inline

Loads the specified html string as the content of the web object.

Returns
  `EINA_TRUE` if it the HTML was successfully loaded, `EINA_FALSE` otherwise

External objects such as stylesheets or images referenced in the HTML document are located relative to base_url.

If an unreachable_url is passed it is used as the url for the loaded content. This is typically used to display error pages for a failed load.

Since
  1.9

Parameters

  html | HTML data to load
  base_url | Base URL used for relative paths to external objects (optional)
  unreachable_url | URL that could not be reached (optional)

References elm_obj_web_html_string_load().

bool elm_web::navigate | ( | int | steps_ | ) | const
| inline

Jumps the given number of steps in the browsing history.

The `steps` value can be a negative integer to back in history, or a positive to move forward.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on error or if not enough history exists to jump the given number of steps

See also
  elm_web_history_enabled_set()
  elm_web_back()
  elm_web_forward()

Parameters

  steps | The number of steps to jump

References elm_obj_web_navigate().

bool elm_web::navigate_possible_get | ( | int | steps_ | ) | const
| inline

Queries whether it's possible to jump the given number of steps.

The `steps` value can be a negative integer to back in history, or a positive to move forward.

Returns
  `EINA_TRUE` if enough history exists to perform the given jump, `EINA_FALSE` otherwise

Parameters

  steps | The number of steps to check for

References elm_obj_web_navigate_possible_get().

bool elm_web::popup_destroy | ( |  | ) | const
| inline

Dismisses an open dropdown popup.

When the popup from a dropdown widget is to be dismissed, either after selecting an option or to cancel it, this function must be called, which will later emit an "popup,willdelete" signal to notify the user that any memory and objects related to this popup can be freed.

Returns
  `EINA_TRUE` if the menu was successfully destroyed, or `EINA_FALSE` if there was no menu to destroy

References elm_obj_web_popup_destroy().

void elm_web::region_bring_in | ( | int | x_,
|  | int | y_,
|  | int | w_,
|  | int | h_
| ) |  | const
| inline

Brings in the region to the visible area.

Like elm_web_region_show(), but it animates the scrolling of the object to show the area

Parameters

  x | The x coordinate of the region to show
  y | The y coordinate of the region to show
  w | The width of the region to show
  h | The height of the region to show

References elm_obj_web_region_bring_in().

void elm_web::region_show | ( | int | x_,
|  | int | y_,
|  | int | w_,
|  | int | h_
| ) |  | const
| inline

Shows the given region in the web object.

Parameters

  x | The x coordinate of the region to show
  y | The y coordinate of the region to show
  w | The width of the region to show
  h | The height of the region to show

References elm_obj_web_region_show().

bool elm_web::reload | ( |  | ) | const
| inline

Requests a reload of the current document in the object.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

References elm_obj_web_reload().

bool elm_web::reload_full | ( |  | ) | const
| inline

Requests a reload of the current document, avoiding any existing caches.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

References elm_obj_web_reload_full().

bool elm_web::stop | ( |  | ) | const
| inline

Stops loading the current page.

Cancels the loading of the current page in the web object. This will cause a "load,error" signal to be emitted, with the is_cancellation flag set to `EINA_TRUE`.

Returns
  `EINA_TRUE` if the cancel was successful, `EINA_FALSE` otherwise

References elm_obj_web_stop().

unsigned int elm_web::text_matches_mark | ( | std::string | string_,
|  | bool | case_sensitive_,
|  | bool | highlight_,
|  | unsigned int | limit_
| ) |  | const
| inline

Marks matches of the given string in a document.

Returns
  number of matched string

Parameters

  string | String to match
  case_sensitive | If match should be case sensitive or not
  highlight | If matches should be highlighted
  limit | Maximum amount of matches, or zero to unlimited

References elm_obj_web_text_matches_mark().

bool elm_web::text_matches_unmark_all | ( |  | ) | const
| inline

Clears all marked matches in the document.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

References elm_obj_web_text_matches_unmark_all().

bool elm_web::text_search | ( | std::string | string_,
|  | bool | case_sensitive_,
|  | bool | forward_,
|  | bool | wrap_
| ) |  | const
| inline

Searches the given string in a document.

Returns
  `EINA_TRUE` if the given string was found, `EINA_FALSE` if not or failure

Parameters

  string | String to search
  case_sensitive | If search should be case sensitive or not
  forward | If search is from cursor and on or backwards
  wrap | If search should wrap at the end

References elm_obj_web_text_search().